# IndustryViewWindow Class Reference

Inheritance diagram for IndustryViewWindow:

## Public Member Functions
| IndustryViewWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | OnPaint ()
| The window must be repainted.
int | DrawInfo (uint left, uint right, uint top)
| Draw the text in the IVW_INFO panel.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
## Private Attributes
byte | editbox_line
| The line clicked to open the edit box.
byte | clicked_line
| The line of the button that has been clicked.
byte | clicked_button
| The button that has been clicked (to raise).
byte | production_offset_y
| The offset of the production texts/buttons.
int | info_height
| Height needed for the IVW_INFO panel.

## Detailed Description

Definition at line 562 of file industry_gui.cpp.

## Member Function Documentation

int IndustryViewWindow::DrawInfo | ( | uint | left,
|  | uint | right,
|  | uint | top |
| ) |  |  | `[inline]`

Draw the text in the IVW_INFO panel.

Parameters:

  | left | Left edge of the panel.
  | right | Right edge of the panel.
  | top | Top edge of the panel.

Returns:
  Expected position of the bottom edge of the panel.

Definition at line 605 of file industry_gui.cpp.

References Industry::accepts_cargo, CALLBACK_FAILED, IndustrySpec::callback_mask, CBID_INDUSTRY_WINDOW_MORE_TEXT, CBM_IND_PRODUCTION_256_TICKS, CBM_IND_PRODUCTION_CARGO_ARRIVAL, CBM_IND_WINDOW_MORE_TEXT, clicked_button, clicked_line, CST_VIEW, CT_INVALID, DrawArrowButtons(), DrawString(), DrawStringMultiLine(), FONT_HEIGHT_NORMAL, CargoSpec::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_industry_pool >::Get(), GetAllCargoSuffixes(), GetGRFStringID(), GetIndustrySpec(), IndustrySpec::grf_prop, GRFFileProps::grffile, HasBit(), Industry::incoming_cargo_waiting, Industry::last_month_pct_transported, Industry::last_month_production, lengthof, Industry::location, CargoSpec::name, PrepareTextRefStackUsage(), Industry::produced_cargo, production_offset_y, SetDParam(), SetDParamStr(), StopTextRefStackUsage(), TileArea::tile, ToPercent8(), Industry::type, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, WD_FRAMERECT_TOP, WD_FRAMETEXT_LEFT, WD_PAR_VSEP_WIDE, and Window::window_number.

Referenced by OnPaint().

virtual void IndustryViewWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 703 of file industry_gui.cpp.

References _ctrl_pressed, clicked_button, clicked_line, CS_ALPHANUMERAL, CT_INVALID, NWidgetBase::current_x, editbox_line, Window::flags4, FONT_HEIGHT_NORMAL, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_industry_pool >::Get(), IsInsideMM(), Window::left, Industry::location, max(), minu(), NWidgetBase::pos_x, Industry::produced_cargo, production_offset_y, Industry::production_rate, Window::SetDirty(), SetDParam(), ShowQueryString(), TileArea::tile, TileDiffXY(), WD_FRAMERECT_RIGHT, WD_FRAMETEXT_LEFT, WF_TIMEOUT_BEGIN, and Window::window_number.

virtual void IndustryViewWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 584 of file industry_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, DrawInfo(), Window::DrawWidgets(), info_height, Window::IsShaded(), NWidgetBase::pos_x, NWidgetBase::pos_y, and Window::ReInit().

virtual void IndustryViewWindow::OnQueryTextFinished | ( | char * | str | ) | `[inline, virtual]`

The query window opened from this window has closed.

Parameters:

  | str | the new value of the string, NULL if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented from Window.

Definition at line 771 of file industry_gui.cpp.

References ClampU(), editbox_line, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_industry_pool >::Get(), Industry::production_rate, Window::SetDirty(), StrEmpty(), and Window::window_number.

virtual void IndustryViewWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 763 of file industry_gui.cpp.

References NWidgetViewport::UpdateViewportCoordinates(), and Window::viewport.

virtual void IndustryViewWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 693 of file industry_gui.cpp.

References SetDParam(), and Window::window_number.

virtual void IndustryViewWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 698 of file industry_gui.cpp.

References info_height.

The documentation for this class was generated from the following file:

- src/industry_gui.cpp